<template>
  <div ref="slider"
       class="horizontal-scrolling draggable no-scrollbars"
       :class="{'active': isDown}"
       v-on:mousedown="mousedown"
       v-on:mouseleave="mouseleave"
       v-on:mouseup="mouseup"
       v-on:mousemove="mousemove"
  >
    <slot></slot>
  </div>
</template>

<script>
export default {
  data: () => ({
    isDown: false,
    startX: null,
    scrollLeft: null
  }),
  methods: {
    mousemove: function (e){
      if (!this.isDown) return
      e.preventDefault()
      const distance = this.$refs.slider.getBoundingClientRect().left | null
      const x = e.pageX - distance
      const walk = x - this.startX
      this.$refs.slider.scrollLeft = this.scrollLeft - walk
    },
    mouseleave: function (){
      this.isDown = false
    },
    mouseup: function (){
      this.isDown = false
    },
    mousedown: function (e){
      this.isDown = true;
      const distance = this.$refs.slider.getBoundingClientRect().left | null
      this.startX = e.pageX - distance
      this.scrollLeft = this.$refs.slider.scrollLeft
    }
  }
}
</script>
